| AI Engine API User Guide (AIE-API) 2025.2

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Static Public Member Functions | Static Public Attributes | List of all members
aie::unary_op< Parent, Operation::None > Struct Template Reference

`#include <expr.hpp>`

## Public Types
using | elem_type = typename Parent::elem_type
using | parent1_type = Parent
using | parent1_type = Parent
using | result_type = op_result_type_t<parent1_type, Operation::None>
using | result_type = op_result_type_t<parent1_type, Operation::None>
using | value_type = op_value_type_t<result_type>
using | value_type = op_value_type_t<result_type>

## Public Member Functions
result_type | operator() () const
result_type | operator() () const
auto | parent1 () const
auto & | parent1 ()

## Static Public Member Functions
static constexpr unsigned | bits ()
static constexpr unsigned | bits ()
template<typename... Operations> requires (... && std::is_same_v<Operations, Operation>)
static constexpr bool | is_operation (Operation op, Operations... ops)
template<typename... Operations> requires (... && std::is_same_v<Operations, Operation>)
static constexpr bool | is_operation (Operation op, Operations... ops)
static constexpr bool | is_operation_none ()
static constexpr bool | is_operation_none ()
template<typename... Operations> requires (... && std::is_same_v<Operations, Operation>)
static constexpr bool | is_operation_not (Operation op, Operations... ops)
template<typename... Operations> requires (... && std::is_same_v<Operations, Operation>)
static constexpr bool | is_operation_not (Operation op, Operations... ops)
static constexpr unsigned | size ()
static constexpr unsigned | size ()

## Static Public Attributes
static constexpr Operation | operation = Op
static constexpr Operation | operation = Op

## Member Typedef Documentation

## ◆ elem_type

template<typename Parent>

using aie::unary_op< Parent, Operation::None >::elem_type = typename Parent::elem_type

## ◆ parent1_type [1/2]

template<typename Parent>

using aie::unary_op< Parent, Operation::None >::parent1_type = Parent

## ◆ parent1_type [2/2]

template<typename Parent>

using aie::unary_op< Parent, Operation::None >::parent1_type = Parent

## ◆ result_type [1/2]

template<typename Parent>

using aie::unary_op< Parent, Operation::None >::result_type = op_result_type_t<parent1_type, Operation::None>

## ◆ result_type [2/2]

template<typename Parent>

using aie::unary_op< Parent, Operation::None >::result_type = op_result_type_t<parent1_type, Operation::None>

## ◆ value_type [1/2]

template<typename Parent>

using aie::unary_op< Parent, Operation::None >::value_type = op_value_type_t<result_type>

## ◆ value_type [2/2]

template<typename Parent>

using aie::unary_op< Parent, Operation::None >::value_type = op_value_type_t<result_type>

## Member Function Documentation

## ◆ bits() [1/2]

template<typename Parent, Operation Op>

static constexpr unsigned aie::unary_op_common< Parent, Op >::bits | ( |  | ) |
| inline static constexpr inherited

## ◆ bits() [2/2]

template<typename Parent, Operation Op>

static constexpr unsigned aie::unary_op_common< Parent, Op >::bits | ( |  | ) |
| inline static constexpr inherited

## ◆ is_operation() [1/2]

template<typename Parent, Operation Op>
template<typename... Operations>
requires (... && std::is_same_v<Operations, Operation>)

static constexpr bool aie::unary_op_common< Parent, Op >::is_operation | ( | Operation | op,
|  | Operations... | ops )
| inline static constexpr inherited

## ◆ is_operation() [2/2]

template<typename Parent, Operation Op>
template<typename... Operations>
requires (... && std::is_same_v<Operations, Operation>)

static constexpr bool aie::unary_op_common< Parent, Op >::is_operation | ( | Operation | op,
|  | Operations... | ops )
| inline static constexpr inherited

## ◆ is_operation_none() [1/2]

template<typename Parent, Operation Op>

static constexpr bool aie::unary_op_common< Parent, Op >::is_operation_none | ( |  | ) |
| inline static constexpr inherited

## ◆ is_operation_none() [2/2]

template<typename Parent, Operation Op>

static constexpr bool aie::unary_op_common< Parent, Op >::is_operation_none | ( |  | ) |
| inline static constexpr inherited

## ◆ is_operation_not() [1/2]

template<typename Parent, Operation Op>
template<typename... Operations>
requires (... && std::is_same_v<Operations, Operation>)

static constexpr bool aie::unary_op_common< Parent, Op >::is_operation_not | ( | Operation | op,
|  | Operations... | ops )
| inline static constexpr inherited

## ◆ is_operation_not() [2/2]

template<typename Parent, Operation Op>
template<typename... Operations>
requires (... && std::is_same_v<Operations, Operation>)

static constexpr bool aie::unary_op_common< Parent, Op >::is_operation_not | ( | Operation | op,
|  | Operations... | ops )
| inline static constexpr inherited

## ◆ operator()() [1/2]

template<typename Parent>

unary_op< Parent, Operation::None >::result_type aie::unary_op< Parent, Operation::None >::operator() | ( |  | ) | const

## ◆ operator()() [2/2]

template<typename Parent>

result_type aie::unary_op< Parent, Operation::None >::operator() | ( |  | ) | const
| inline

## ◆ parent1() [1/2]

auto aie::unary_op_common_const< Parent, Op >::parent1 | ( |  | ) | const
| inline inherited

## ◆ parent1() [2/2]

auto & aie::unary_op_common_ref< Parent, Op >::parent1 | ( |  | ) |
| inline inherited

## ◆ size() [1/2]

template<typename Parent, Operation Op>

static constexpr unsigned aie::unary_op_common< Parent, Op >::size | ( |  | ) |
| inline static constexpr inherited

## ◆ size() [2/2]

template<typename Parent, Operation Op>

static constexpr unsigned aie::unary_op_common< Parent, Op >::size | ( |  | ) |
| inline static constexpr inherited

## Member Data Documentation

## ◆ operation [1/2]

template<typename Parent, Operation Op>

Operation aie::unary_op_common< Parent, Op >::operation = Op
| static constexpr inherited

## ◆ operation [2/2]

template<typename Parent, Operation Op>

Operation aie::unary_op_common< Parent, Op >::operation = Op
| static constexpr inherited

The documentation for this struct was generated from the following file:

- expr.hpp